PROGRAM RUN

!!!!!!!!!!!!!!!!!!!!!!!!
!!   USE STATEMENTS   !!
!!!!!!!!!!!!!!!!!!!!!!!!    
USE PARAMETERS
USE GLOBAL
USE AUXILIARY
USE LAPACK95
USE IFPORT
USE OMP_LIB
   
IMPLICIT NONE  
    
!! MISC ARGUMENTS
INTEGER             :: number_of_threads
INTEGER             :: num = 0

!! MAIN PROGRAM    
number_of_threads = OMP_get_max_threads()
number_of_threads = NINT(DBLE(number_of_threads)*0.75_dp)
CALL OMP_set_num_threads(number_of_threads)
PRINT *, 'number of OMP threads', number_of_threads
    
WRITE (*,*) ' RUN MENU '

DO
    WRITE (*,*) ' --***---***-- '
    WRITE (*,*) ' Enter the number of the routine to run '
    WRITE (*,*) ' (01)  BASELINE '
    WRITE (*,*) ' (00)  QUIT '
    READ (*,*) num    

    !! create global tables needed
    !! CREATE r_grid
    CALL creategrid(r_grid,N_r,rmin,rmin,rmax,onepwr)

    !! CREATE PHI_GRID
    CALL creategrid(PHI_GRID,N_phi,phimin,phimin,phimax,onepwr)    

    !! CREATE rho_grid
    CALL creategrid(rho_grid,N_rho,rhomin,rhomax,rhomax,onepwr)
        
    !! CREATE RHOP_GRID
    CALL creategrid(RHOP_GRID,N_rhop,rhopmin,rhopmax,rhopmax,onepwr)

    !! CREATE k_grid
    CALL creategrid(k_grid,N_k,kmin,kmin,kmax,onepwr)

    SELECT CASE (num)
    CASE(1)
        CALL run_baseline
    CASE DEFAULT
        EXIT
    END SELECT

END DO

CONTAINS    
    
    SUBROUTINE run_baseline
    
        USE IFPORT
    
        ! local vars
        REAL(DP)                        ::  capsule_time_start, capsule_time_stop

        !! begin
        WRITE (*,*) 'RUN BASELINE - BEGIN'

        capsule_time_start    = DCLOCK() 
        CALL baseline
        capsule_time_stop     = DCLOCK() 

100         FORMAT (1X, A, ' took: ', F12.3, ' seconds')     
    
        IF (TRACE_TRACK) THEN
            WRITE (*,100) 'CALIBRATION ', capsule_time_stop - capsule_time_start
        END IF     
    
        WRITE (*,*) 'WRITING RESULTS'
    
        CALL printResults
    
        WRITE (*,*) 'RUN BASELINE - END'
    
    END SUBROUTINE run_baseline    
      
END PROGRAM  RUN

!!!!!!!!!!!!!!!!!!!!!!!!
!!    END PROGRAM     !!
!!!!!!!!!!!!!!!!!!!!!!!!  

